#include <string.h>
#include <stdlib.h>
#include <stdio.h>
#include <assert.h>
#include <gtk/gtk.h>

#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>

/* for setlocale */
#include <locale.h>

/* for gettext */
#include <libintl.h>
#define _(text) gettext(text)
#define __(text) text

#define die(args...) { fprintf(stderr, args); exit(1); }
#define die_(f) { perror(f); exit(1); }

#define GTK_FLUSH \
    while (gtk_events_pending()) \
        gtk_main_iteration();


extern char *error_msg, *error_msg2, *error_button_msg;


#define strbase(base, s) strncmp(base, s, strlen(base)) == 0

extern void initlocale(const char *package);
extern int strput(char *p, char *a, char *b, int size);
extern int strput3(char *p, char *a, char *b, char *c, int size);
extern int streq(const char *a, const char *b);
extern void myread(char *p, FILE *f, size_t size);
extern int get_int(FILE *f) ;
extern char *get_string(FILE *f, int *size);
extern char **get_string_array(FILE *f, int *nb);
extern GtkWidget *PACK_(GtkWidget *parent, GtkWidget *widget, gint vert, gint horiz, gint padding);
extern GtkWidget *PACK00_(GtkWidget *parent, GtkWidget *widget, gint padding);
extern GtkWidget *PACK10_(GtkWidget *parent, GtkWidget *widget, gint padding);
extern GtkWidget *PACK01_(GtkWidget *parent, GtkWidget *widget, gint padding);
extern GtkWidget *PACK11_(GtkWidget *parent, GtkWidget *widget, gint padding);
extern GtkWidget *PACK00(GtkWidget *parent, GtkWidget *widget);
extern GtkWidget *PACK10(GtkWidget *parent, GtkWidget *widget);
extern GtkWidget *PACK01(GtkWidget *parent, GtkWidget *widget);
extern GtkWidget *PACK11(GtkWidget *parent, GtkWidget *widget);
extern void _gtk_error_(char *msg, char *msg2, char *button_msg);
